﻿/*
 * Created by SharpDevelop.
 * User: Marco José
 * Date: 08-01-2007
 * Time: 22:52
 */

using System;

using MySql.Data.MySqlClient;
using MySql.Data;

namespace adav
{
	
	/// <summary>
	/// Description of IUtilizador.
	/// </summary>
	public interface IUtilizador
	{
		/// <summary>
		/// Login de um utilizador na aplicação
		/// </summary>
		/// <param name="username"></param>
		/// <param name="password"></param>
		/// <returns> o tipo do utilizador </returns>
		OperationStatus Login(string username, string password);
		
		
		///
		TiposUtilizador ObterTipoUtilizador(string username, string password);
		
	}

	/// <summary>
	/// Description of Utilizador.
	/// </summary>
	public class Utilizador : IUtilizador 
	{
		public Utilizador()
		{
		}
		
		public OperationStatus Login(string username, string password)
		{
			return DBHelper.ValidateUser(username,password);
		}
		
		public TiposUtilizador ObterTipoUtilizador(string username, string password) {
			return DBHelper.GetUserType(username, password);
		}
	}
}
