CREATE TABLE `adav`.`cartao`
(
   num_telemovel varchar(9) PRIMARY KEY not null,
   tipo_cartao varchar(1) not null,
   saldo double not null,
   estado_cartao varchar(1) not null,
   id_tarifario int unsigned not null
);
CREATE TABLE `adav`.`cartao_cliente`
(
   num_telemovel varchar(9) not null,
   id_cliente int unsigned not null,
   CONSTRAINT `adav`.`cartao_cliente`_PK PRIMARY KEY (num_telemovel,id_cliente)
);
CREATE TABLE `adav`.`chamada`
(
   num_telemovel varchar(9) not null,
   num_destino varchar(9) not null,
   data_inicio datetime not null,
   data_fim datetime,
   duracao bigint unsigned,
   custo_chamada double unsigned,
   estado_chamada varchar(1) not null,
   id_chamada int unsigned PRIMARY KEY not null
);
CREATE TABLE `adav`.`ciclo_tarifario`
(
   id_ciclo int unsigned PRIMARY KEY not null,
   descricao varchar(45) not null
);
CREATE TABLE `adav`.`cliente`
(
   id_cliente int unsigned PRIMARY KEY not null,
   nome varchar(45) not null,
   morada varchar(45) not null,
   num_contribuinte varchar(9) not null
);
CREATE TABLE `adav`.`funcionario`
(
   id_funcionario int unsigned PRIMARY KEY not null,
   tipo_funcionario char(1) not null,
   username varchar(45) not null,
   password varchar(16) not null,
   comissao_total double unsigned not null
);
CREATE TABLE `adav`.`periodo`
(
   id_periodo int unsigned not null,
   id_ciclo int unsigned not null,
   hora_inicio char(4) not null,
   hora_fim char(4) not null,
   CONSTRAINT `adav`.`periodo`_PK PRIMARY KEY (id_periodo,id_ciclo)
);
CREATE TABLE `adav`.`rede`
(
   id_rede int unsigned PRIMARY KEY not null,
   descricao varchar(45) not null,
   prefixo varchar(5)
);
CREATE TABLE `adav`.`tarifario`
(
   id_tarifario int unsigned PRIMARY KEY not null,
   descricao varchar(45) not null,
   data_ultima_alteracao datetime not null,
   comissao double not null
);
CREATE TABLE `adav`.`tarifario_detalhe`
(
   id_tarifario int unsigned not null,
   id_unidade int unsigned not null,
   id_rede int unsigned not null,
   id_periodo int unsigned not null,
   unidades_minimas int unsigned not null,
   custo_unidade double unsigned not null,
   CONSTRAINT `adav`.`tarifario_detalhe`_PK PRIMARY KEY (id_tarifario,id_unidade,id_rede,id_periodo)
);
CREATE TABLE `adav`.`unidade`
(
   id_unidade int unsigned PRIMARY KEY not null,
   descricao varchar(45) not null,
   unidade tinyint unsigned
);

ALTER TABLE cartao
ADD CONSTRAINT FK_ID_TARIFARIO
FOREIGN KEY (id_tarifario)
REFERENCES tarifario(id_tarifario) ON DELETE NO ACTION ON UPDATE CASCADE;
CREATE INDEX FK_ID_TARIFARIO ON cartao(id_tarifario);
ALTER TABLE cartao_cliente
ADD CONSTRAINT FK_CLIENTE
FOREIGN KEY (id_cliente)
REFERENCES cliente(id_cliente) ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE cartao_cliente
ADD CONSTRAINT FK_CARTAO
FOREIGN KEY (num_telemovel)
REFERENCES cartao(num_telemovel) ON DELETE NO ACTION ON UPDATE NO ACTION;
CREATE INDEX FK_CLIENTE ON cartao_cliente(id_cliente);
ALTER TABLE chamada
ADD CONSTRAINT FK_NUM_TELEMOVEL
FOREIGN KEY (num_telemovel)
REFERENCES cartao(num_telemovel) ON DELETE CASCADE ON UPDATE NO ACTION;
CREATE INDEX FK_NUM_TELEMOVEL ON chamada(num_telemovel);
ALTER TABLE periodo
ADD CONSTRAINT FK_CICLO
FOREIGN KEY (id_ciclo)
REFERENCES ciclo_tarifario(id_ciclo) ON DELETE CASCADE ON UPDATE NO ACTION;
CREATE INDEX FK_CICLO ON periodo(id_ciclo);
ALTER TABLE tarifario_detalhe
ADD CONSTRAINT FK_REDE
FOREIGN KEY (id_rede)
REFERENCES rede(id_rede) ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE tarifario_detalhe
ADD CONSTRAINT FK_TARIFARIO
FOREIGN KEY (id_tarifario)
REFERENCES tarifario(id_tarifario) ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE tarifario_detalhe
ADD CONSTRAINT FK_UNIDADE
FOREIGN KEY (id_unidade)
REFERENCES unidade(id_unidade) ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE tarifario_detalhe
ADD CONSTRAINT FK_PERIODO
FOREIGN KEY (id_periodo)
REFERENCES periodo(id_periodo) ON DELETE CASCADE ON UPDATE NO ACTION;
CREATE INDEX FK_REDE ON tarifario_detalhe(id_rede);
CREATE INDEX FK_UNIDADE ON tarifario_detalhe(id_unidade);
CREATE INDEX FK_PERIODO ON tarifario_detalhe(id_periodo);
